local addon, ns = ...
local cfg = CreateFrame("Frame")

--media
cfg.backdrop_edge_texture = "Interface\\AddOns\\oUF_Qulight\\media\\textures\\backdrop_edge"
cfg.statusbar_texture = "Interface\\AddOns\\oUF_Qulight\\media\\textures\\normTex"
cfg.powerbar_texture = "Interface\\AddOns\\oUF_Qulight\\media\\textures\\normTex"
cfg.backdrop_texture = "Interface\\AddOns\\oUF_Qulight\\media\\textures\\backdrop"
cfg.highlight_texture = "Interface\\AddOns\\oUF_Qulight\\media\\textures\\raidbg"
cfg.debuffBorder = "Interface\\AddOns\\oUF_Qulight\\media\\textures\\iconborder"

cfg.font = "Interface\\AddOns\\oUF_Qulight\\media\\fonts\\font.ttf" -- main font oUF_Qulight
cfg.fontsize = 12

cfg.HealFrames = false -- Raid Frames for healers
cfg.showIndicators = true -- buffs indicators on healframes only
cfg.showAuraWatch = true -- buffs timer on raid frames(hots, shields etc)
cfg.ShowParty = true -- show party frames (shown as 5man raid)
cfg.ShowRaid = true -- show raid frames
cfg.RaidShowSolo = false -- show raid frames even when solo
cfg.RaidShowAllGroups = false -- show raid groups 6, 7 and 8 (more than 25man raid)
cfg.enableDebuffHighlight = true -- enable *dispelable* debuff highlight for raid frames
cfg.showRaidDebuffs = true -- enable important debuff icons to show on raid units
cfg.showtot = true -- show target of target frame
cfg.showpet = true -- show pet frame
cfg.showfocus = true -- show focus frame
cfg.showfocustarget = true -- show focus target frame
cfg.showBossFrames = true -- show boss frame
cfg.TotemBars = true -- show Totem Bars
cfg.MTFrames = false -- show main tank frames
cfg.ArenaFrames  = false -- show arena frame
cfg.Reputationbar = true -- show Reputation bar
cfg.Experiencebar = true -- show Experience bar
cfg.showPlayerAuras = false -- use a custom player buffs/debuffs frame instead of Blizzard's default.
cfg.ThreatBar = true  -- show Threat Bar
cfg.showRunebar = true -- show DK rune bar
cfg.showHolybar = true -- show Paladin HolyPower bar
cfg.showEclipsebar = true -- show druid Eclipse bar
cfg.showShardbar = true -- show Warlock SoulShard bar
cfg.RCheckIcon = true -- show raid check icon
cfg.Castbars = false -- use built-in castbars
cfg.showLFDIcons = true -- Show dungeon role icons in raid/party
cfg.showPortrait = false -- enable/disable portrait
cfg.buffsOnlyShowPlayer = false -- show buffs only on players
cfg.enableDebuffHighlight = false

--Frame positions: x - horizontal position, y - vertical position, w - frame width, h - frame height
--player
cfg.playerx = -265
cfg.playery = 200
cfg.playerw = 245
cfg.playerh = 30

--target
cfg.targetx = 155
cfg.targety = 200
cfg.targetw = 245
cfg.targeth = 30

--pet 
cfg.petx = -580
cfg.pety = 173
cfg.petw = 120
cfg.peth = 27

--tot
cfg.totx = 470
cfg.toty = 173
cfg.totw = 120
cfg.toth = 27

--focus
cfg.focusx = -1280
cfg.focusy = 0
cfg.focusw = 200
cfg.focush = 27

--focus target - aligned left from focusframe
cfg.ftargetw = 120
cfg.ftargeth = 27

--party
cfg.partyx = 256
cfg.partyy = -310

--raid
cfg.raidx = -5
cfg.raidy = 10
cfg.raidw = 80
cfg.raidh = 17

-- arena frames
cfg.arenax = -10
cfg.arenay = 50
cfg.arenaw = 120
cfg.arenay = 27

-- boss frames
cfg.bossx = -10
cfg.bossy = 50
cfg.bossw = 150
cfg.bossh = 37

-- main tank frames
cfg.MTx = -700
cfg.MTy = 0
cfg.MTw = 100
cfg.MTh = 25



ns.cfg = cfg